# trober_sdk (EXPERIMENTAL)
The trober API

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.8
- Build package: org.openapitools.codegen.languages.DartDioNextClientCodegen

## Requirements

* Dart 2.12.0 or later OR Flutter 1.26.0 or later
* Dio 4.0.0+
* timemachine option currently **DOES NOT** support sound null-safety and may not work

## Installation & Usage

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```
name: trober_sdk
version: 0.0.44
description: The trober SDK
dependencies:
  trober_sdk:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
      version: 'any'
```

### Local
To use the package in your local drive, please include the following in pubspec.yaml
```
dependencies:
  trober_sdk:
    path: /path/to/trober_sdk
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:trober_sdk/trober_sdk.dart';


final api = DefaultApi();

try {
    final response = await api.appinfoGet();
    print(response);
} catch on DioError (e) {
    print("Exception when calling DefaultApi->appinfoGet: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://trober-test.herokuapp.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**appinfoGet**](doc/DefaultApi.md#appinfoget) | **get** /appinfo | Get supported App info
*DefaultApi* | [**carriersGet**](doc/DefaultApi.md#carriersget) | **get** /carriers | List all Carriers
*DefaultApi* | [**carriersIdGet**](doc/DefaultApi.md#carriersidget) | **get** /carriers/{id} | Get carrier details
*DefaultApi* | [**carriersIdPut**](doc/DefaultApi.md#carriersidput) | **put** /carriers/{id} | Update an existing carrier
*DefaultApi* | [**carriersPost**](doc/DefaultApi.md#carrierspost) | **post** /carriers | Create a new Carrier
*DefaultApi* | [**customersGet**](doc/DefaultApi.md#customersget) | **get** /customers | List all Customers
*DefaultApi* | [**customersIdGet**](doc/DefaultApi.md#customersidget) | **get** /customers/{id} | Get customer details
*DefaultApi* | [**customersIdPut**](doc/DefaultApi.md#customersidput) | **put** /customers/{id} | Update an existing customer
*DefaultApi* | [**customersPost**](doc/DefaultApi.md#customerspost) | **post** /customers | Create a new Customer
*DefaultApi* | [**healthGet**](doc/DefaultApi.md#healthget) | **get** /health | Get server health
*DefaultApi* | [**ordersGet**](doc/DefaultApi.md#ordersget) | **get** /orders | List all Orders
*DefaultApi* | [**ordersIdGet**](doc/DefaultApi.md#ordersidget) | **get** /orders/{id} | Get order details
*DefaultApi* | [**ordersIdPut**](doc/DefaultApi.md#ordersidput) | **put** /orders/{id} | Update an existing order
*DefaultApi* | [**ordersPost**](doc/DefaultApi.md#orderspost) | **post** /orders | Create a new Order
*DefaultApi* | [**selfDeviceRegisterPost**](doc/DefaultApi.md#selfdeviceregisterpost) | **post** /self/device-register | Register the device for the user
*DefaultApi* | [**selfDeviceRemovePost**](doc/DefaultApi.md#selfdeviceremovepost) | **post** /self/device-remove | Remove the device for the user
*DefaultApi* | [**selfGet**](doc/DefaultApi.md#selfget) | **get** /self | Get details of the logged in user
*DefaultApi* | [**selfTenantGet**](doc/DefaultApi.md#selftenantget) | **get** /self/tenant | Get tenant details of the logged in user
*DefaultApi* | [**shipmentsGet**](doc/DefaultApi.md#shipmentsget) | **get** /shipments | List all Shipments
*DefaultApi* | [**shipmentsIdGet**](doc/DefaultApi.md#shipmentsidget) | **get** /shipments/{id} | Get shipment details
*DefaultApi* | [**shipmentsIdPut**](doc/DefaultApi.md#shipmentsidput) | **put** /shipments/{id} | Update an existing shipment
*DefaultApi* | [**shipmentsPost**](doc/DefaultApi.md#shipmentspost) | **post** /shipments | Create a new Shipment
*DefaultApi* | [**tenantsGet**](doc/DefaultApi.md#tenantsget) | **get** /tenants | List all tenants
*DefaultApi* | [**tenantsIdGet**](doc/DefaultApi.md#tenantsidget) | **get** /tenants/{id} | Get tenant details
*DefaultApi* | [**tenantsIdPut**](doc/DefaultApi.md#tenantsidput) | **put** /tenants/{id} | Update an existing tenant
*DefaultApi* | [**tenantsPost**](doc/DefaultApi.md#tenantspost) | **post** /tenants | Create a new tenant
*DefaultApi* | [**terminalsGet**](doc/DefaultApi.md#terminalsget) | **get** /terminals | List all Terminals
*DefaultApi* | [**terminalsIdGet**](doc/DefaultApi.md#terminalsidget) | **get** /terminals/{id} | Get terminal details
*DefaultApi* | [**terminalsIdPut**](doc/DefaultApi.md#terminalsidput) | **put** /terminals/{id} | Update an existing terminal
*DefaultApi* | [**terminalsPost**](doc/DefaultApi.md#terminalspost) | **post** /terminals | Create a new Terminal
*DefaultApi* | [**usersGet**](doc/DefaultApi.md#usersget) | **get** /users | List all users
*DefaultApi* | [**usersIdDelete**](doc/DefaultApi.md#usersiddelete) | **delete** /users/{id} | Delete the user
*DefaultApi* | [**usersIdGet**](doc/DefaultApi.md#usersidget) | **get** /users/{id} | Get user details
*DefaultApi* | [**usersIdPut**](doc/DefaultApi.md#usersidput) | **put** /users/{id} | Update an existing user
*DefaultApi* | [**usersPost**](doc/DefaultApi.md#userspost) | **post** /users | Create a new user


## Documentation For Models

 - [AppInfo](doc/AppInfo.md)
 - [Carrier](doc/Carrier.md)
 - [CarrierType](doc/CarrierType.md)
 - [Customer](doc/Customer.md)
 - [DeviceId](doc/DeviceId.md)
 - [Error](doc/Error.md)
 - [Order](doc/Order.md)
 - [OrderStatus](doc/OrderStatus.md)
 - [Shipment](doc/Shipment.md)
 - [ShipmentSize](doc/ShipmentSize.md)
 - [ShipmentStatus](doc/ShipmentStatus.md)
 - [ShipmentType](doc/ShipmentType.md)
 - [Tenant](doc/Tenant.md)
 - [TenantType](doc/TenantType.md)
 - [Terminal](doc/Terminal.md)
 - [TerminalType](doc/TerminalType.md)
 - [User](doc/User.md)
 - [UserRole](doc/UserRole.md)


## Documentation For Authorization


## ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-TOKEN
- **Location**: HTTP header


## Author




