# trober_sdk.api.DefaultApi

## Load the API package
```dart
import 'package:trober_sdk/api.dart';
```

All URIs are relative to *https://trober-test.herokuapp.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**appinfoGet**](DefaultApi.md#appinfoget) | **get** /appinfo | Get supported App info
[**carriersGet**](DefaultApi.md#carriersget) | **get** /carriers | List all Carriers
[**carriersIdGet**](DefaultApi.md#carriersidget) | **get** /carriers/{id} | Get carrier details
[**carriersIdPut**](DefaultApi.md#carriersidput) | **put** /carriers/{id} | Update an existing carrier
[**carriersPost**](DefaultApi.md#carrierspost) | **post** /carriers | Create a new Carrier
[**customersGet**](DefaultApi.md#customersget) | **get** /customers | List all Customers
[**customersIdGet**](DefaultApi.md#customersidget) | **get** /customers/{id} | Get customer details
[**customersIdPut**](DefaultApi.md#customersidput) | **put** /customers/{id} | Update an existing customer
[**customersPost**](DefaultApi.md#customerspost) | **post** /customers | Create a new Customer
[**healthGet**](DefaultApi.md#healthget) | **get** /health | Get server health
[**ordersGet**](DefaultApi.md#ordersget) | **get** /orders | List all Orders
[**ordersIdGet**](DefaultApi.md#ordersidget) | **get** /orders/{id} | Get order details
[**ordersIdPut**](DefaultApi.md#ordersidput) | **put** /orders/{id} | Update an existing order
[**ordersPost**](DefaultApi.md#orderspost) | **post** /orders | Create a new Order
[**selfDeviceRegisterPost**](DefaultApi.md#selfdeviceregisterpost) | **post** /self/device-register | Register the device for the user
[**selfDeviceRemovePost**](DefaultApi.md#selfdeviceremovepost) | **post** /self/device-remove | Remove the device for the user
[**selfGet**](DefaultApi.md#selfget) | **get** /self | Get details of the logged in user
[**selfTenantGet**](DefaultApi.md#selftenantget) | **get** /self/tenant | Get tenant details of the logged in user
[**shipmentsGet**](DefaultApi.md#shipmentsget) | **get** /shipments | List all Shipments
[**shipmentsIdGet**](DefaultApi.md#shipmentsidget) | **get** /shipments/{id} | Get shipment details
[**shipmentsIdPut**](DefaultApi.md#shipmentsidput) | **put** /shipments/{id} | Update an existing shipment
[**shipmentsPost**](DefaultApi.md#shipmentspost) | **post** /shipments | Create a new Shipment
[**tenantsGet**](DefaultApi.md#tenantsget) | **get** /tenants | List all tenants
[**tenantsIdGet**](DefaultApi.md#tenantsidget) | **get** /tenants/{id} | Get tenant details
[**tenantsIdPut**](DefaultApi.md#tenantsidput) | **put** /tenants/{id} | Update an existing tenant
[**tenantsPost**](DefaultApi.md#tenantspost) | **post** /tenants | Create a new tenant
[**terminalsGet**](DefaultApi.md#terminalsget) | **get** /terminals | List all Terminals
[**terminalsIdGet**](DefaultApi.md#terminalsidget) | **get** /terminals/{id} | Get terminal details
[**terminalsIdPut**](DefaultApi.md#terminalsidput) | **put** /terminals/{id} | Update an existing terminal
[**terminalsPost**](DefaultApi.md#terminalspost) | **post** /terminals | Create a new Terminal
[**usersGet**](DefaultApi.md#usersget) | **get** /users | List all users
[**usersIdDelete**](DefaultApi.md#usersiddelete) | **delete** /users/{id} | Delete the user
[**usersIdGet**](DefaultApi.md#usersidget) | **get** /users/{id} | Get user details
[**usersIdPut**](DefaultApi.md#usersidput) | **put** /users/{id} | Update an existing user
[**usersPost**](DefaultApi.md#userspost) | **post** /users | Create a new user


# **appinfoGet**
> AppInfo appinfoGet()

Get supported App info

Get supported App info

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();

try { 
    var result = api_instance.appinfoGet();
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->appinfoGet: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**AppInfo**](AppInfo.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **carriersGet**
> BuiltList<Carrier> carriersGet(tenantId, name, page, type)

List all Carriers

List all Carriers

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
var name = name_example; // String | The name of the carrier. Matches names that begin with the values
var page = page_example; // int | The page number
var type = ; // CarrierType | The type of the carrier.

try { 
    var result = api_instance.carriersGet(tenantId, name, page, type);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->carriersGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 
 **name** | **String**| The name of the carrier. Matches names that begin with the values | [optional] 
 **page** | **int**| The page number | [optional] 
 **type** | [**CarrierType**](.md)| The type of the carrier. | [optional] 

### Return type

[**BuiltList<Carrier>**](Carrier.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **carriersIdGet**
> Carrier carriersIdGet(id, tenantId)

Get carrier details

Get carrier details

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the carrier
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try { 
    var result = api_instance.carriersIdGet(id, tenantId);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->carriersIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the carrier | 
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 

### Return type

[**Carrier**](Carrier.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **carriersIdPut**
> Carrier carriersIdPut(id, carrier)

Update an existing carrier

Update an existing carrier

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the carrier
var carrier = new Carrier(); // Carrier | 

try { 
    var result = api_instance.carriersIdPut(id, carrier);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->carriersIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the carrier | 
 **carrier** | [**Carrier**](Carrier.md)|  | [optional] 

### Return type

[**Carrier**](Carrier.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **carriersPost**
> Carrier carriersPost(carrier)

Create a new Carrier

Create a new Carrier

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var carrier = new Carrier(); // Carrier | 

try { 
    var result = api_instance.carriersPost(carrier);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->carriersPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **carrier** | [**Carrier**](Carrier.md)|  | [optional] 

### Return type

[**Carrier**](Carrier.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **customersGet**
> BuiltList<Customer> customersGet(tenantId, name, page)

List all Customers

List all Customers

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
var name = name_example; // String | The name of the customer. Matches names that begin with the values
var page = page_example; // int | The page number

try { 
    var result = api_instance.customersGet(tenantId, name, page);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->customersGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 
 **name** | **String**| The name of the customer. Matches names that begin with the values | [optional] 
 **page** | **int**| The page number | [optional] 

### Return type

[**BuiltList<Customer>**](Customer.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **customersIdGet**
> Customer customersIdGet(id, tenantId)

Get customer details

Get customer details

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the customer
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try { 
    var result = api_instance.customersIdGet(id, tenantId);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->customersIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the customer | 
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 

### Return type

[**Customer**](Customer.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **customersIdPut**
> Customer customersIdPut(id, customer)

Update an existing customer

Update an existing customer

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the customer
var customer = new Customer(); // Customer | 

try { 
    var result = api_instance.customersIdPut(id, customer);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->customersIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the customer | 
 **customer** | [**Customer**](Customer.md)|  | [optional] 

### Return type

[**Customer**](Customer.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **customersPost**
> Customer customersPost(customer)

Create a new Customer

Create a new Customer

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var customer = new Customer(); // Customer | 

try { 
    var result = api_instance.customersPost(customer);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->customersPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customer** | [**Customer**](Customer.md)|  | [optional] 

### Return type

[**Customer**](Customer.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **healthGet**
> healthGet()

Get server health

Get server health status

### Example 
```dart
import 'package:trober_sdk/api.dart';

var api_instance = new DefaultApi();

try { 
    api_instance.healthGet();
} catch (e) {
    print('Exception when calling DefaultApi->healthGet: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ordersGet**
> BuiltList<Order> ordersGet(tenantId, page, customerId, serialNumber, status)

List all Orders

List all Orders

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
var page = page_example; // int | The page number
var customerId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the customer
var serialNumber = serialNumber_example; // String | The serialNumber of the order. Matches serialNumber that begin with the values
var status = ; // OrderStatus | The status of the order.

try { 
    var result = api_instance.ordersGet(tenantId, page, customerId, serialNumber, status);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->ordersGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 
 **page** | **int**| The page number | [optional] 
 **customerId** | [**String**](.md)| The id of the customer | [optional] 
 **serialNumber** | **String**| The serialNumber of the order. Matches serialNumber that begin with the values | [optional] 
 **status** | [**OrderStatus**](.md)| The status of the order. | [optional] 

### Return type

[**BuiltList<Order>**](Order.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ordersIdGet**
> Order ordersIdGet(id, tenantId)

Get order details

Get order details

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the order
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try { 
    var result = api_instance.ordersIdGet(id, tenantId);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->ordersIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the order | 
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 

### Return type

[**Order**](Order.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ordersIdPut**
> Order ordersIdPut(id, order)

Update an existing order

Update an existing order

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the order
var order = new Order(); // Order | 

try { 
    var result = api_instance.ordersIdPut(id, order);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->ordersIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the order | 
 **order** | [**Order**](Order.md)|  | [optional] 

### Return type

[**Order**](Order.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ordersPost**
> Order ordersPost(order)

Create a new Order

Create a new Order

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var order = new Order(); // Order | 

try { 
    var result = api_instance.ordersPost(order);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->ordersPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **order** | [**Order**](Order.md)|  | [optional] 

### Return type

[**Order**](Order.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **selfDeviceRegisterPost**
> selfDeviceRegisterPost(deviceId)

Register the device for the user

Register the device for the user

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var deviceId = new DeviceId(); // DeviceId | 

try { 
    api_instance.selfDeviceRegisterPost(deviceId);
} catch (e) {
    print('Exception when calling DefaultApi->selfDeviceRegisterPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceId** | [**DeviceId**](DeviceId.md)|  | [optional] 

### Return type

void (empty response body)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **selfDeviceRemovePost**
> selfDeviceRemovePost(deviceId)

Remove the device for the user

Remove the device for the user

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var deviceId = new DeviceId(); // DeviceId | 

try { 
    api_instance.selfDeviceRemovePost(deviceId);
} catch (e) {
    print('Exception when calling DefaultApi->selfDeviceRemovePost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **deviceId** | [**DeviceId**](DeviceId.md)|  | [optional] 

### Return type

void (empty response body)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **selfGet**
> User selfGet()

Get details of the logged in user

Get details of the logged in user

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();

try { 
    var result = api_instance.selfGet();
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->selfGet: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**User**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **selfTenantGet**
> Tenant selfTenantGet()

Get tenant details of the logged in user

Get tenant details of the logged in user

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();

try { 
    var result = api_instance.selfTenantGet();
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->selfTenantGet: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**Tenant**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **shipmentsGet**
> BuiltList<Shipment> shipmentsGet(tenantId, orderId, carrierId, page, driverId, serialNumber, type, status, size)

List all Shipments

List all Shipments

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
var orderId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the order
var carrierId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the carrier
var page = page_example; // int | The page number
var driverId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the driver
var serialNumber = serialNumber_example; // String | The serialNumber of the shipment. Matches serialNumber that begin with the values
var type = ; // ShipmentType | The type of the shipment.
var status = ; // ShipmentStatus | The status of the shipment.
var size = ; // ShipmentSize | The size of the shipment.

try { 
    var result = api_instance.shipmentsGet(tenantId, orderId, carrierId, page, driverId, serialNumber, type, status, size);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->shipmentsGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 
 **orderId** | [**String**](.md)| The id of the order | [optional] 
 **carrierId** | [**String**](.md)| The id of the carrier | [optional] 
 **page** | **int**| The page number | [optional] 
 **driverId** | [**String**](.md)| The id of the driver | [optional] 
 **serialNumber** | **String**| The serialNumber of the shipment. Matches serialNumber that begin with the values | [optional] 
 **type** | [**ShipmentType**](.md)| The type of the shipment. | [optional] 
 **status** | [**ShipmentStatus**](.md)| The status of the shipment. | [optional] 
 **size** | [**ShipmentSize**](.md)| The size of the shipment. | [optional] 

### Return type

[**BuiltList<Shipment>**](Shipment.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **shipmentsIdGet**
> Shipment shipmentsIdGet(id, tenantId)

Get shipment details

Get shipment details

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the shipment
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try { 
    var result = api_instance.shipmentsIdGet(id, tenantId);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->shipmentsIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the shipment | 
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 

### Return type

[**Shipment**](Shipment.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **shipmentsIdPut**
> Shipment shipmentsIdPut(id, shipment)

Update an existing shipment

Update an existing shipment

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the shipment
var shipment = new Shipment(); // Shipment | 

try { 
    var result = api_instance.shipmentsIdPut(id, shipment);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->shipmentsIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the shipment | 
 **shipment** | [**Shipment**](Shipment.md)|  | [optional] 

### Return type

[**Shipment**](Shipment.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **shipmentsPost**
> Shipment shipmentsPost(shipment)

Create a new Shipment

Create a new Shipment

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var shipment = new Shipment(); // Shipment | 

try { 
    var result = api_instance.shipmentsPost(shipment);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->shipmentsPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **shipment** | [**Shipment**](Shipment.md)|  | [optional] 

### Return type

[**Shipment**](Shipment.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **tenantsGet**
> BuiltList<Tenant> tenantsGet(name, page, type)

List all tenants

List all tenants

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var name = name_example; // String | The name of the tenant. Matches names that begin with the values
var page = page_example; // int | The page number
var type = ; // TenantType | The type of the tenant.

try { 
    var result = api_instance.tenantsGet(name, page, type);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->tenantsGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**| The name of the tenant. Matches names that begin with the values | [optional] 
 **page** | **int**| The page number | [optional] 
 **type** | [**TenantType**](.md)| The type of the tenant. | [optional] 

### Return type

[**BuiltList<Tenant>**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **tenantsIdGet**
> Tenant tenantsIdGet(id)

Get tenant details

Get tenant details

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try { 
    var result = api_instance.tenantsIdGet(id);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->tenantsIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the tenant | 

### Return type

[**Tenant**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **tenantsIdPut**
> Tenant tenantsIdPut(id, tenant)

Update an existing tenant

Update an existing tenant

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
var tenant = new Tenant(); // Tenant | 

try { 
    var result = api_instance.tenantsIdPut(id, tenant);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->tenantsIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the tenant | 
 **tenant** | [**Tenant**](Tenant.md)|  | [optional] 

### Return type

[**Tenant**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **tenantsPost**
> Tenant tenantsPost(tenant)

Create a new tenant

Create a new tenant

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var tenant = new Tenant(); // Tenant | 

try { 
    var result = api_instance.tenantsPost(tenant);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->tenantsPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenant** | [**Tenant**](Tenant.md)|  | [optional] 

### Return type

[**Tenant**](Tenant.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **terminalsGet**
> BuiltList<Terminal> terminalsGet(tenantId, page, name, type)

List all Terminals

List all Terminals

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
var page = page_example; // int | The page number
var name = name_example; // String | The name of the terminal. Matches names that begin with the values
var type = ; // TerminalType | The type of the terminal.

try { 
    var result = api_instance.terminalsGet(tenantId, page, name, type);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->terminalsGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 
 **page** | **int**| The page number | [optional] 
 **name** | **String**| The name of the terminal. Matches names that begin with the values | [optional] 
 **type** | [**TerminalType**](.md)| The type of the terminal. | [optional] 

### Return type

[**BuiltList<Terminal>**](Terminal.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **terminalsIdGet**
> Terminal terminalsIdGet(id, tenantId)

Get terminal details

Get terminal details

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the terminal
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try { 
    var result = api_instance.terminalsIdGet(id, tenantId);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->terminalsIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the terminal | 
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 

### Return type

[**Terminal**](Terminal.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **terminalsIdPut**
> Terminal terminalsIdPut(id, terminal)

Update an existing terminal

Update an existing terminal

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the terminal
var terminal = new Terminal(); // Terminal | 

try { 
    var result = api_instance.terminalsIdPut(id, terminal);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->terminalsIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the terminal | 
 **terminal** | [**Terminal**](Terminal.md)|  | [optional] 

### Return type

[**Terminal**](Terminal.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **terminalsPost**
> Terminal terminalsPost(terminal)

Create a new Terminal

Create a new Terminal

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var terminal = new Terminal(); // Terminal | 

try { 
    var result = api_instance.terminalsPost(terminal);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->terminalsPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **terminal** | [**Terminal**](Terminal.md)|  | [optional] 

### Return type

[**Terminal**](Terminal.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersGet**
> BuiltList<User> usersGet(tenantId, page, name, role)

List all users

List all users

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant
var page = page_example; // int | The page number
var name = name_example; // String | The name of the customer. Matches names that begin with the values
var role = ; // UserRole | The role of the user

try { 
    var result = api_instance.usersGet(tenantId, page, name, role);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->usersGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 
 **page** | **int**| The page number | [optional] 
 **name** | **String**| The name of the customer. Matches names that begin with the values | [optional] 
 **role** | [**UserRole**](.md)| The role of the user | [optional] 

### Return type

[**BuiltList<User>**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersIdDelete**
> usersIdDelete(id)

Delete the user

Delete the user

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the user

try { 
    api_instance.usersIdDelete(id);
} catch (e) {
    print('Exception when calling DefaultApi->usersIdDelete: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the user | 

### Return type

void (empty response body)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersIdGet**
> User usersIdGet(id, tenantId)

Get user details

Get user details

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the user
var tenantId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the tenant

try { 
    var result = api_instance.usersIdGet(id, tenantId);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->usersIdGet: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the user | 
 **tenantId** | [**String**](.md)| The id of the tenant | [optional] 

### Return type

[**User**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersIdPut**
> User usersIdPut(id, user)

Update an existing user

Update an existing user

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var id = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | The id of the user
var user = new User(); // User | 

try { 
    var result = api_instance.usersIdPut(id, user);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->usersIdPut: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**String**](.md)| The id of the user | 
 **user** | [**User**](User.md)|  | [optional] 

### Return type

[**User**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **usersPost**
> User usersPost(user)

Create a new user

Create a new user

### Example 
```dart
import 'package:trober_sdk/api.dart';
// TODO Configure API key authorization: ApiKeyAuth
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKey = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//defaultApiClient.getAuthentication<ApiKeyAuth>('ApiKeyAuth').apiKeyPrefix = 'Bearer';

var api_instance = new DefaultApi();
var user = new User(); // User | 

try { 
    var result = api_instance.usersPost(user);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->usersPost: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user** | [**User**](User.md)|  | [optional] 

### Return type

[**User**](User.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

